﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace DocumentWrappedStyleService
{
   [ServiceContract]
   public interface ICustomerService
   {
      [OperationContract]
      void RegisterCustomer(Customer request);
   }

   [DataContract]
   public class Customer
   {
      [DataMember]
      public string FirstName { get; set; }
      [DataMember]
      public string LastName { get; set; }
      [DataMember]
      public DateTime BirthDate { get; set; }
      [DataMember]
      public int NumberOfWidgets { get; set; }
   } 

   class Program
   {
      static void Main(string[] args)
      {
         ServiceHost rpcServiceHost = new ServiceHost(typeof(CustomerService));
         rpcServiceHost.Open();

         Console.WriteLine("Document/Literal/Wrapped style service started.");
         Console.WriteLine("Press <enter> to exit.");
         Console.ReadLine();

         rpcServiceHost.Close();    
      }
   }

     

   public class CustomerService : ICustomerService
   {
      public void RegisterCustomer(Customer request)
      {         
      }
   }
}
