﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Web;
using System.Text;
using Microsoft.ServiceModel.Web.SpecializedServices;

namespace RESTClient
{
   class Program
   {
      static void Main(string[] args)
      {
         CustomerServiceClient client = new CustomerServiceClient();         
         client.Register(new Customer
                               {
                                  BirthDate = new DateTime(1984, 4, 9),
                                  FirstName = "Szymon",
                                  LastName = "Pobiega",
                                  NumberOfWidgets = 5
                               });
         //client.Close();
      }
   }

   [ServiceContract]
   public interface ICustomerService
   {
      [OperationContract]
      [WebInvoke(Method = "POST", 
         BodyStyle = WebMessageBodyStyle.Bare, 
         ResponseFormat = WebMessageFormat.Xml, 
         UriTemplate = "")]
      void Register(Customer customer);      
   }

   public class CustomerServiceClient : ClientBase<ICustomerService>, ICustomerService
   {
      public void Register(Customer customer)
      {
         Channel.Register(customer);
      }
   }
   
   [DataContract(Namespace = "")]
   public class Customer
   {
      [DataMember]
      public string FirstName { get; set; }
      [DataMember]
      public string LastName { get; set; }
      [DataMember]
      public DateTime BirthDate { get; set; }
      [DataMember]
      public int NumberOfWidgets { get; set; }
   }
}
